# Copyright (c) 2002-2007, RedIRIS. All Rights Reserved.
#
# You may distribute under the terms of the GNU General Public License,
# as specified in the LICENSE file that was shipped with this distribution.

package PAPI::POST_Handler;
use LWP::UserAgent;
use strict;
use Apache2::Const;

sub handler
{
	my $r = shift;
	my $url=$r->uri;
	my $args=$r->args;
	my $host=$r->get_server_name;
	my $psrv=$r->get_server_port;
	$host .= ":".$psrv if ( $psrv != 80 );
	$url .= "?$args" if ( $args ne "");

	my $ua = new LWP::UserAgent;
	my $req = HTTP::Request->new($r->method, "http://$host$url");


	my %hdrs = $r->headers_in();
	for my $hdr (keys %hdrs) {
		$req->header ($hdr, $hdrs{$hdr});
  	}

	$req->content($r->notes('CONTENT_req'));


	my $res = $ua->simple_request($req);
	my $content=$res->content;
  	$r->status($res->code);
  	$res->scan(sub {
		$r->headers_out(@_);		
	});
	$r->content_type($res->content_type);
	$r->headers_out('Content-length'=> length($res->content));   
	$r->print($content);
	return OK;
}

1;
 
__END__
